#define _XOPEN_SOURCE
#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/PushB.h>
#include <Xmd/Icon.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#include "icons/appCalculator.xbm"
#include "icons/appEditor.xbm"
#include "icons/appFiles.xbm"
#include "icons/appMail.xbm"
#include "icons/appTerminal.xbm"
#include "icons/appWebBrowser.xbm"

typedef struct {
	Pixmap icon;
	const char * command;
} Launcher;

void   createAllLaunchers (Widget);
Widget createLauncher (Widget, Launcher);
void   activateLauncher (Widget, XtPointer, XtPointer);

XtAppContext application;

int main (int argc, char *argv[]) {
	Widget window = XtVaAppInitialize (
		&application, "Panel",
		NULL, 0,
		&argc, argv,
		NULL, NULL);
		
	Widget layout = XtVaCreateWidget (
		"layout", xmRowColumnWidgetClass, window,
		XmNorientation, XmHORIZONTAL,
		NULL);
	createAllLaunchers(layout);
	
	XtManageChild(layout);
	XtRealizeWidget(window);
	XtAppMainLoop(application);
}

void createAllLaunchers (Widget parent) {
	#define add(name, cmd) createLauncher(parent, (Launcher){\
		.icon = XmdLoadBitmapIcon(parent, app##name),\
		.command = cmd " &"\
	} );
	add(Calculator, "xcalc");
	add(Editor, "nedit");
	add(Files, "caja");
	add(Mail, "nedit");
	add(Terminal, "xterm");
	add(WebBrowser, "firefox");
	#undef add
}

Widget createLauncher (Widget parent, Launcher launcher) {
	Widget button = XtVaCreateManagedWidget (
		"launcher", xmPushButtonWidgetClass, parent,
		XmNleftAttachment, XmATTACH_FORM,
		XmNlabelType,      XmPIXMAP,
		XmNlabelPixmap,    launcher.icon,
		NULL);
	XtAddCallback(button, XmNactivateCallback, activateLauncher, (XtPointer)(launcher.command));
	return button;
}

void activateLauncher (Widget button, XtPointer clientData, XtPointer callData) {
	(void)(button);
	(void)(callData);
	system((char *)(clientData));
}
